ifndef _LINK_
_LINK_ equ 1

; --=====================================================================================--
; LINK CLASS
; --=====================================================================================--
; Built by NaN's Object Class Creator
;  Sept 1, 2001
;
; By NaN ( jaymeson@hotmail.com )
; http://nan32asm.cjb.net
;
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   LINK_Init    PROTO  :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   LINK_destructorPto    TYPEDEF  PROTO  :DWORD 
   LINK_getDataPto    TYPEDEF  PROTO  :DWORD
   LINK_getNextPto    TYPEDEF  PROTO  :DWORD
   LINK_getPrevPto    TYPEDEF  PROTO  :DWORD
   LINK_setDataPto    TYPEDEF  PROTO  :DWORD, :DWORD
   LINK_setNextPto    TYPEDEF  PROTO  :DWORD, :DWORD
   LINK_setPrevPto    TYPEDEF  PROTO  :DWORD, :DWORD

; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--

   CLASS LINK, LINK
      CMETHOD destructor     ; MUST BE THE FIRST, OR OBJECTS.INC WILL FAIL
      CMETHOD getData        ; Method: get the value of Data in eax
      CMETHOD getNext        ; Method: get the value of Next in eax
      CMETHOD getPrev        ; Method: get the value of Prev in eax
      CMETHOD setData        ; Method: set the value of Data
      CMETHOD setNext        ; Method: set the value of Next
      CMETHOD setPrev        ; Method: set the value of Prev
      Data     dd    ?
      Next     dd    ?
      Prev     dd    ?
   LINK ENDS

.data

   BEGIN_INIT
      dd offset LINK_destructor_Funct
      dd offset LINK_getData_Funct
      dd offset LINK_getNext_Funct
      dd offset LINK_getPrev_Funct
      dd offset LINK_setData_Funct
      dd offset LINK_setNext_Funct
      dd offset LINK_setPrev_Funct
      dd NULL
      dd NULL
      dd NULL
   END_INIT

.code
; --=====================================================================================--
; CLASS CONSTRUCTOR
; --=====================================================================================--
LINK_Init  PROC uses edi esi lpTHIS:DWORD
   SET_CLASS LINK
   SetObject edi, LINK
   

   ReleaseObject edi
   ret
LINK_Init ENDP

; --=====================================================================================--
; destructor METHOD BEHAVIOR
; --=====================================================================================--
LINK_destructor_Funct  PROC uses edi lpTHIS:DWORD 
   SetObject edi, LINK

   METHOD edi, LINK, getData            ; Get the lpData pointer to return 

   ReleaseObject edi
   ret
LINK_destructor_Funct  ENDP

; --=====================================================================================--
; getData METHOD BEHAVIOR
; --=====================================================================================--
LINK_getData_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, LINK

   mov eax, [edi].Data

   ReleaseObject edi
   ret
LINK_getData_Funct  ENDP

; --=====================================================================================--
; getNext METHOD BEHAVIOR
; --=====================================================================================--
LINK_getNext_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, LINK

   mov eax, [edi].Next

   ReleaseObject edi
   ret
LINK_getNext_Funct  ENDP

; --=====================================================================================--
; getPrev METHOD BEHAVIOR
; --=====================================================================================--
LINK_getPrev_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, LINK

   mov eax, [edi].Prev

   ReleaseObject edi
   ret
LINK_getPrev_Funct  ENDP

; --=====================================================================================--
; setData METHOD BEHAVIOR
; --=====================================================================================--
LINK_setData_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, LINK

   mov eax, DATA
   mov [edi].Data, eax

   ReleaseObject edi
   ret
LINK_setData_Funct  ENDP

; --=====================================================================================--
; setNext METHOD BEHAVIOR
; --=====================================================================================--
LINK_setNext_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, LINK

   mov eax, DATA
   mov [edi].Next, eax

   ReleaseObject edi
   ret
LINK_setNext_Funct  ENDP

; --=====================================================================================--
; setPrev METHOD BEHAVIOR
; --=====================================================================================--
LINK_setPrev_Funct  PROC uses edi lpTHIS:DWORD, DATA:DWORD
   SetObject edi, LINK

   mov eax, DATA
   mov [edi].Prev, eax

   ReleaseObject edi
   ret
LINK_setPrev_Funct  ENDP

endif