ifndef _JPicture_
_JPicture_ equ 1

include CPicture.asm

; --=====================================================================================--
; JPicture CLASS
; --=====================================================================================--
; Built by NaN's Object Class Creator
;  Sept 1, 2001
;
; By NaN ( jaymeson@hotmail.com )
; http://nan32asm.cjb.net
;
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   JPicture_Init    PROTO  :DWORD, :DWORD, :DWORD, :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   JPic_destructorPto    TYPEDEF  PROTO  :DWORD 
   JPic_CenterOnMousePto    TYPEDEF  PROTO  :DWORD, :DWORD
   JPic_IsClickedPto    TYPEDEF  PROTO  :DWORD, :DWORD

; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--

   CLASS JPicture, JPic
      CPicture     <>         ; Inherited Class
      CMETHOD  CenterOnMouse  ; Takes Standard LParam from Mouse Message
      CMETHOD  IsClicked      ; Uses Standard LParam of Click Messages
   JPicture ENDS

.data

   BEGIN_INIT
      dd offset JPic_destructor_Funct
      dd offset JPic_CenterOnMouse_Funct
      dd offset JPic_IsClicked_Funct
   END_INIT



.code
; --=====================================================================================--
; CLASS CONSTRUCTOR
; --=====================================================================================--
JPicture_Init  PROC uses edi esi lpTHIS:DWORD, A:DWORD, B:DWORD, D:DWORD
   SET_CLASS JPicture INHERITS CPicture, A, B, D
   SetObject edi, JPicture

   ReleaseObject edi
   ret
JPicture_Init ENDP

; --=====================================================================================--
; destructor METHOD BEHAVIOR
; --=====================================================================================--
JPic_destructor_Funct  PROC uses edi lpTHIS:DWORD 
   SetObject edi, JPicture

     SUPER destructor
     
   ReleaseObject edi
   ret
JPic_destructor_Funct  ENDP

; --=====================================================================================--
; CenterOnMouse METHOD BEHAVIOR
; --=====================================================================================--
JPic_CenterOnMouse_Funct  PROC uses edi lpTHIS:DWORD, A:DWORD
   SetObject edi, JPicture

   mov eax, A
   shr eax, 16
   mov [edi].yPos, eax
   mov eax, A
   and eax, 0FFFFh
   mov [edi].xPos, eax
   
   xor eax, eax
   add ax, [edi].pHeight
   shr eax, 1
   sub [edi].yPos, eax

   xor eax, eax
   mov ax, [edi].pWidth
   shr eax, 1
   sub [edi].xPos, eax
   
   ReleaseObject edi
   ret
JPic_CenterOnMouse_Funct  ENDP

; --=====================================================================================--
; IsClicked METHOD BEHAVIOR
; --=====================================================================================--
JPic_IsClicked_Funct  PROC uses edi lpTHIS:DWORD, A:DWORD
   LOCAL Pt :POINT
   LOCAL Rt :RECT
   
   SetObject edi, JPicture
 
   mov eax, A
   and eax, 0FFFFh
   mov Pt.x, eax
   
   mov eax, A
   shr eax, 16
   mov Pt.y, eax
   
   mov eax, [edi].xPos
   mov Rt.left, eax
   
   mov eax, [edi].yPos
   mov Rt.top, eax
   
   xor eax, eax
   mov ax, [edi].pHeight
   add eax, Rt.top
   mov Rt.bottom, eax
   
   xor eax, eax
   mov ax, [edi].pWidth
   add eax, Rt.left
   mov Rt.right, eax
   
  
   invoke PtInRect, addr Rt, Pt.x, Pt.y
   
   ReleaseObject edi
   ret
JPic_IsClicked_Funct  ENDP

endif