ifndef _Painter_
_Painter_ equ 1

include CPaint.asm
include LNKLST.asm
; --=====================================================================================--
; Painter CLASS
; --=====================================================================================--
; Built by NaN's Object Class Creator
;  Sept 1, 2001
;
; By NaN ( jaymeson@hotmail.com )
; http://nan32asm.cjb.net
;
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   Painter_Init    PROTO  :DWORD, :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   Pain_destructorPto    TYPEDEF  PROTO  :DWORD 
   Pain_PaintAllPto    TYPEDEF PROTO  :DWORD, :DWORD, :DWORD

; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--

   CLASS Painter, Pain
      LNKLST     <>         ; Inherited Class
      CMETHOD PaintAll      ; Needs hWin, hDC
   Painter ENDS

.data   

   BEGIN_INIT 
      dd offset Pain_destructor_Funct
      dd offset Pain_PaintAll_Funct
   END_INIT



.code
; --=====================================================================================--
; CLASS CONSTRUCTOR
; --=====================================================================================--
Painter_Init  PROC uses edi esi lpTHIS:DWORD, Opt:DWORD
   SET_CLASS Painter INHERITS LNKLST, Opt
   SetObject edi, Painter
     

   ReleaseObject edi
   ret
Painter_Init ENDP

; --=====================================================================================--
; destructor METHOD BEHAVIOR
; --=====================================================================================--
Pain_destructor_Funct PROC uses edi lpTHIS:DWORD 
   SetObject edi, Painter
     
     SUPER destructor

   ReleaseObject edi
   ret
Pain_destructor_Funct  ENDP

; --=====================================================================================--
; PaintAll METHOD BEHAVIOR
; --=====================================================================================--
Pain_PaintAll_Funct PROC uses edi esi ebx lpTHIS:DWORD, A:DWORD, B:DWORD
   LOCAL TEMP :DWORD
   LOCAL Rct  :RECT

   SetObject edi, Painter

     ; Save current link pointer
     mov TEMP, $EAX( edi, LNKLST, getCURLNK )
     
     ; Move the link to the start of the list..
     METHOD edi, LNKLST, setCURLNK, $EAX( edi, LNKLST, getlpHead ) 
     
     ; Get the # of links..
     mov esi, $EAX( edi, LNKLST, getNodeCount )   
     .if (esi > 0 )
          
        ; get the first Object from the list..
        mov ebx, $EAX( edi, LNKLST, getNode ) 
        .while (esi > 0)

           ; Do Inerface'd paint method
           METHOD ebx, CPaint, Paint, A, B    
           
           ; Decrement the object count...
           dec esi                        
           ; if still objects left in the list..
           .if (esi > 0)    
              ; get the next object..
              mov ebx, $EAX( edi, LNKLST, getNextNode )
           .endif
        .endw
     .endif
     
     ; restore the current link..
     METHOD edi, LNKLST, setCURLNK, TEMP
     
   ReleaseObject edi
   ret
Pain_PaintAll_Funct  ENDP

endif